Option Explicit

'++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
' Word}l[WNX
'++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
Class WordManager

    'bZ[W
    Private mstrMessage

    'hLg
    Private mstrDocName

    'WordAvP[VIuWFNg
    Private mobjWord

    'WordhLgIuWFNg
    Private mobjDoc

    'RXgN^
    Private Sub Class_Initialize()
        mstrMessage = ""

        Set mobjWord = CreateObject("Word.Application")
    End Sub

    'fXgN^
    Private Sub Class_Terminate()
        mobjWord.Quit

        Set mobjDoc = Nothing
        Set mobjWord = Nothing
    End Sub

    '************************************************************
    ' vpeBFMessage
    ' Tv@@@@FbZ[W
    '************************************************************
    Public Property Get Message()
        Message = mstrMessage
    End Property
    Private Property Let Message(ByVal strMsg)
        mstrMessage = strMsg
    End Property

    '************************************************************
    ' vpeBFDocName
    ' Tv@@@@FWordhLg
    '************************************************************
    Public Property Get DocName()
        DocName = mstrDocName
    End Property
    Public Property Let DocName(ByVal strDocNm)
        On Error Resume Next

        WordDocument = WordApplication.Documents.Open(strDocNm)

        If Not (Err.Number = 0) Then
            Message = CStr(Err.Number) & ":" & Err.Description
            Err.Clear
            Exit Property
        End If

        On Error GoTo 0

        mstrDocName = strDocNm
    End Property

    '************************************************************
    ' vpeBFWordApplication
    ' Tv@@@@FWordAvP[VIuWFNg
    '************************************************************
    Private Property Get WordApplication()
        Set WordApplication = mobjWord
    End Property
    Private Property Let WordApplication(ByVal objWord)
        Set mobjWord = objWord
    End Property

    '************************************************************
    ' vpeBFWordDocument
    ' Tv@@@@FWordhLgIuWFNg
    '************************************************************
    Private Property Get WordDocument()
        Set WordDocument = mobjDoc
    End Property
    Private Property Let WordDocument(ByVal objDoc)
        Set mobjDoc = objDoc
    End Property

    '************************************************************
    ' \bhFCloseDocument
    ' Tv@@@FWordhLg
    ' p[^FȂ
    ' ߂l@@FȂ
    '************************************************************
    Public Sub CloseDocument()
        WordDocument.Close
    End Sub

    '************************************************************
    ' \bhFGetText
    ' Tv@@@FWordhLgSeLXg擾
    ' p[^FȂ
    ' ߂l@@FWordhLg̑SeLXg
    '************************************************************
    Public Function GetText()
        WordDocument.Select
        GetText = WordApplication.Selection.Text
    End Function
End Class
